<?php
namespace Teknisa\SUP\Modules\Cotacao\Modules\PlanilhaCotacao\Controllers; 

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;

class QuantidadeCotacaoProdutoController extends \Teknisa\GER\Controllers\TeknisaCrud {
    protected $dataSourceName = 'quantidadeCotacaoProduto';
    protected $entityManager;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $dataSourceManager;

    public function __construct($crudService, $parameterBag, $entityManager, $newCode, $environment, $connection, $dataSourceManager) {
        $this->entityManager     = $entityManager;
        $this->newCode           = $newCode;
        $this->environment       = $environment;
        $this->connection        = $connection;
        $this->dataSourceManager = $dataSourceManager;
    }
    
    public function setDefault(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $query = "SELECT NMFILIAL FROM FILIAL WHERE CDFILCENTCMP IS NULL AND :CDFILIAL = CDFILIAL";
        $query = $this->connection->prepare($query);
        $query->execute(array(
            "CDFILIAL" => $this->environment->getCdFilial()
        ));
        $filial = $query->fetchAll();

        if(empty($filial)){
            $sql = "SELECT NMFILIAL, CDFILIAL FROM FILIAL WHERE CDFILIAL = (SELECT CDFILCENTCMP FROM FILIAL WHERE :CDFILIAL = CDFILIAL)";
            $query = $this->connection->prepare($sql);
            $query->execute(array(
                "CDFILIAL" => $this->environment->getCdFilial()
            ));
        
            $filial = $query->fetchAll()[0];
            
        }
        
        $dataSet = new DataSet('filial', array($filial));
     
        $response->addDataSet($dataSet);
    }
}