<?php
namespace Teknisa\SUP\Modules\Relatorio\Controllers;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;

class Sup03100EvolucaoPrecosController extends \Teknisa\GER\Controllers\TeknisaCrud 
{
    
    protected $crudService;
    protected $entityManager;
    protected $evolucaoPrecosService;
    protected $dataSourceManager;
    
    public function __construct($crudService, $parameterBag, $evolucaoPrecosService, $dataSourceManager, EntityManager $entityManager) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->evolucaoPrecosService = $evolucaoPrecosService;
        $this->dataSourceManager = $dataSourceManager;
        $this->entityManager = $entityManager;
    }
    
    public function getEvolucaoPrecos(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $filterCriteria = $request->getFilterCriteria();
            
            $conditions = $this->evolucaoPrecosService->getConditionsFromFilter($filterCriteria);
            $stProximoCodigo = $this->evolucaoPrecosService->setTrabEvolPrec($conditions);
            $this->evolucaoPrecosService->setEvolucaoPrecos($stProximoCodigo, $conditions);
            $produto = $this->evolucaoPrecosService->getEvolucaoPrecosProduto($stProximoCodigo);
            
            $response->addDataSet(new DataSet('data', $produto));
            
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));   
        }
    }
    
    public function getDatasEvolPrecos(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $conditions = $request->getFilterCriteria()->getConditions();
            $rows = $this->crudService->getFilteredDataSet("sup03100_evol_prec_datas", $conditions, $request->getFilterCriteria()->getPage(), $request->getFilterCriteria()->getPageSize())->getRows();
            $rowsToSave = array();
            foreach($rows as $key => $row){
                if(is_null($row['VRPERCEVOL'])) {
                    $row['VRPERCEVOL'] = 'XXX';
                }
                $rowsToSave[$key] = $row;
            }
            $response->addDataSet(new DataSet("datas", $rowsToSave));
            
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));   
        }
    }
}